
/*****************************************************************************/
/*  Include File for Visual C/C++ (32- and 64-Bit)                           */
/*****************************************************************************/
#ifndef _MATRIXRTC_API_H
#define _MATRIXRTC_API_H

#include "mxtypes.h" 

#if defined(__APPLE__) || defined(__unix__)
	#ifndef __WATCOMC__
		#define WINAPI
	#endif
#else
   #if !defined(WINAPI)
      #define WINAPI __stdcall
   #endif
#endif

#if !defined(BOOL)
  #define BOOL int
#endif

#if !defined(LOWORD)
    #define LOWORD(l)           ((_mxINT16)(((_mxINT32)(l)) & 0xffff))
#endif

#if !defined(HIWORD)
    #define HIWORD(l)           ((_mxINT16)((((_mxINT32)(l)) >> 16) & 0xffff))
#endif

#ifdef __cplusplus
extern "C" {
#endif

_mxINT16  WINAPI Init_MatrixAPI(void);
_mxINT16  WINAPI Release_MatrixAPI(void);
_mxINT32  WINAPI GetVersionAPI(void);
_mxINT32  WINAPI GetVersionDRV(void);
_mxINT32  WINAPI GetVersionDRV_USB(void);
_mxINT16  WINAPI GetPortAdr(_mxINT16);
_mxINT16  WINAPI Dongle_WriteData(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16);
_mxINT16  WINAPI Dongle_WriteDataEx(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16, _mxINT16);
_mxINT16  WINAPI Dongle_ReadData(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16);
_mxINT16  WINAPI Dongle_ReadDataEx(_mxINT32, _mxINT32*, _mxINT16, _mxINT16, _mxINT16, _mxINT16);
_mxINT32  WINAPI Dongle_ReadSerNr(_mxINT32, _mxINT16, _mxINT16);
_mxINT16  WINAPI Dongle_Find(void);
_mxINT32  WINAPI Dongle_Version(_mxINT16, _mxINT16);
_mxINT32  WINAPI Dongle_Model(_mxINT16, _mxINT16);
_mxINT16  WINAPI Dongle_MemSize(_mxINT16, _mxINT16);
_mxINT16  WINAPI Dongle_Count(_mxINT16);

_mxINT16  WINAPI Dongle_WriteKey(_mxINT32 UserCode, 
                                    _mxINT32 *KeyData, 
                                    _mxINT16 DongleNr, 
                                    _mxINT16 PortNr);

_mxINT16  WINAPI Dongle_GetKeyFlag(_mxINT32 UserCode, _mxINT16 DongleNr, _mxINT16 PortNr);

_mxINT16  WINAPI Dongle_EncryptData(_mxINT32 UserCode, _mxINT32 *DataBlock, _mxINT16 DongleNr, _mxINT16 PortNr);
_mxINT16  WINAPI Dongle_DecryptData(_mxINT32 UserCode, _mxINT32 *DataBlock, _mxINT16 DongleNr, _mxINT16 PortNr);

_mxINT16 WINAPI Dongle_SetLED( _mxINT16 mode, _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_GetTime( _mxINT32 UserCode, _mxUINT32* nTime, _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_GetRand( _mxINT32 UserCode, _mxINT16 siz, unsigned char* pRand, _mxINT16 dNr, _mxINT16 PortNr );

_mxINT16 WINAPI Dongle_CreateRSAKeyPair( _mxINT32 UserCode, _mxINT16 idx, _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_LockRSAKeyPair( _mxINT32 UserCode, _mxINT16 idx, BOOL bLock, _mxUINT32 lockKey, _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_GetRSAPubKey( _mxINT32 UserCode, _mxINT16 idx, unsigned char* modulus, short* modulus_len, 
					unsigned char* exponent, short* exponent_len, _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_EncryptDataRSA( _mxINT32 UserCode, _mxINT16 idx, 
				 unsigned char* plainText, short plainTextLen, unsigned char* cipher, short* cipherLen,
				 _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_DecryptDataRSA( _mxINT32 UserCode, _mxINT16 idx, 
				 unsigned char* cipher, short cipherLen, unsigned char* plainText, short* plainTextLen,
				 _mxINT16 dNr, _mxINT16 PortNr );

_mxINT16 WINAPI Dongle_DecryptDataTDES( _mxINT32 UserCode, unsigned char* iv, char*cipher, _mxINT16 cipherLen, char*plain, _mxINT16* plainLen,
																		 _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_EncryptDataTDES( _mxINT32 UserCode, unsigned char* iv, char*plainText, _mxINT16 plainLen, char*cipher, _mxINT16* cipherLen,
																		 _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_WriteKeyTDES(_mxINT32 UserCode, unsigned char* key, _mxINT16 dNr, _mxINT16 PortNr );

_mxINT16 WINAPI Dongle_WriteKeyHMACSHA1(_mxINT32 UserCode, unsigned char* key, _mxINT16 dNr, _mxINT16 PortNr );
_mxINT16 WINAPI Dongle_HMACSHA1(_mxINT32 UserCode, char*plainText, _mxINT16 plainLen, char*hash, _mxINT16* hashLen,
																		 _mxINT16 dNr, _mxINT16 PortNr );

_mxINT16 WINAPI Dongle_MemSize2(_mxINT16 dNr, _mxINT16 PortNr);
_mxINT16 WINAPI Dongle_WriteData2(_mxINT32 UserCode, unsigned char* data, _mxUINT16 pos, _mxUINT16 len, _mxINT16 dNr, _mxINT16 PortNr);
_mxINT16 WINAPI Dongle_ReadData2(_mxINT32 UserCode, unsigned char* data, _mxUINT16 pos, _mxUINT16 len, _mxINT16 dNr, _mxINT16 PortNr);
_mxINT16 WINAPI Dongle_LockData2(_mxINT32 UserCode, BOOL bLock, _mxUINT32 lockKey, _mxINT16 dNr, _mxINT16 PortNr);

_mxINT16 WINAPI Dongle_LockData(_mxINT32 UserCode, BOOL bLock, _mxUINT32 lockKey, _mxINT16 dNr, _mxINT16 PortNr);

_mxINT16 WINAPI Dongle_SetTimer(_mxINT32 UserCode, _mxINT16 mode,  _mxINT16 dNr, _mxINT16 PortNr);
_mxINT16 WINAPI Dongle_StartTimer(_mxINT32 UserCode, _mxINT16 dNr, _mxINT16 PortNr);
_mxINT16 WINAPI Dongle_GetTimer(_mxINT32 UserCode, _mxUINT32* dwCount,  _mxINT16 dNr, _mxINT16 PortNr);
_mxINT16 WINAPI Dongle_StopTimer(_mxINT32 UserCode, _mxINT16 dNr, _mxINT16 PortNr);

_mxINT16 WINAPI Dongle_ReadGUSN(_mxINT32 UserCode, unsigned char* gSN, _mxINT16 dNr, _mxINT16 PortNr);

_mxINT16  WINAPI SetConfig_MatrixNet(_mxINT16, char*);
_mxINT16  WINAPI LogIn_MatrixNet(_mxINT32, _mxINT16, _mxINT16);
_mxINT16  WINAPI LogOut_MatrixNet(_mxINT32, _mxINT16, _mxINT16);
_mxINT32  WINAPI GetConfig_MatrixNet(_mxINT16 Category);

#ifdef __cplusplus
}
#endif

#endif  // _MATRIXRTC_API_H

